<script setup>
import { ref, onMounted } from "vue";
import { useRoute } from "vue-router";
import api from "../../api";

// Get route information
const route = useRoute();
const bukus = ref(null);
const genre = ref(null);
const searchQuery = ref("");

// Fetch book details based on the id parameter
const fetchBookDetails = async () => {
  console.log(route.params);

  try {
    const response = await api.get(`/bukubygenre/${route.params.id}`);
    bukus.value = response.data.bukus;
    genre.value = response.data.genre;
    console.log(response);
  } catch (error) {
    console.error("Error fetching book details:", error);
  }
};

const searchBooks = async () => {
  try {
    const response = await api.get(`/bukubygenre/${route.params.id}`, {
      params: {
        search: searchQuery.value,
      },
    });
    bukus.value = response.data.bukus;
    genre.value = response.data.genre;
  } catch (error) {
    console.error("Error searching books:", error);
  }
};

onMounted(() => {
  fetchBookDetails();
});
</script>

<template>
  <section class="pt-5">
    <div class="container">
      <div class="row pt-5">
        <div class="col">
          <h1>Genre {{ genre }}</h1>
        </div>
        <div class="col d-flex justify-content-end">
          <form @submit.prevent="searchBooks" class="form-inline">
            <div class="input-group">
              <input
                v-model="searchQuery"
                type="text"
                class="form-control"
                size="50"
                placeholder="Cari buku disini..."
              />
              <div class="input-group-append">
                <button class="btn btn-secondary" type="submit">
                  <i class="fa fa-search"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
  </section>

  <section>
    <div class="container py-4 vh-100">
      <div class="row">
        <div class="row">
          <div
            class="col"
            v-for="Buku in bukus"
            :key="Buku.buku_id"
            style="margin-bottom: 20px"
          >
            <div
              class="card"
              style="width: 15rem; height: auto; margin: 0 auto"
            >
              <div
                class="card-body"
                style="
                  display: flex;
                  flex-direction: column;
                  justify-content: space-between;
                "
              >
                <div class="frame" style="width: 207px; height: 311px">
                  <img
                    :src="Buku.cover"
                    class="card-img-top pb-3"
                    style="
                      max-width: 100%;
                      max-height: 100%;
                      object-fit: cover;
                      object-position: center;
                    "
                    alt=""
                  />
                </div>
                <h5 class="card-title text-truncate">{{ Buku.title }}</h5>
                <p
                  class="card-text m-0"
                  style="max-width: 100%; color: rgb(88, 83, 83)"
                >
                  {{ Buku.author }}
                </p>
                <p class="card-text" style="max-width: 100%; color: darkcyan">
                  <!-- Rp{{ formatPrice(Buku.price) }} -->
                </p>
                <router-link
                  :to="{ name: 'pages.katalog', params: { id: Buku.buku_id } }"
                  class="btn btn-primary"
                  style="margin-top: auto"
                  >Lihat</router-link
                >
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
